﻿using UnityEngine;

public class ReadonlyAttribute : PropertyAttribute { }

public static class ExtensionFunctions
{
    public static float RelativeAngle(this float v) {
        while (v >= 180f) v -= 360f;
        while (v < -180f) v += 360f;
        return v;
    }

    public static Vector3 RelativeAngles(this Vector3 v) => 
        new Vector3(v.x.RelativeAngle(), v.y.RelativeAngle(), v.z.RelativeAngle());

    public static Vector4 RelativeAngles(this Vector4 v) => 
        new Vector4(v.x.RelativeAngle(), v.y.RelativeAngle(), v.z.RelativeAngle(), v.w.RelativeAngle());
}